'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var utilsCommons = require('@highlight-ui/utils-commons');
var utilsHooks = require('@highlight-ui/utils-hooks');
var utilsPortalManager = require('@highlight-ui/utils-portal-manager');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles = {
  "offsetVarName": "--tooltip-offset",
  "tooltip": "Tooltip-module__wN2gX2dn__v4-2-0-r18-0"
};
var Trigger = React__default["default"].forwardRef(function (_a, ref) {
  var Component = _a.component,
    children = _a.children,
    props = __rest(_a, ["component", "children"]);
  return React__default["default"].createElement(Component, __assign({
    ref: ref
  }, props), children);
});
var DELAY_VALUES = {
  none: 0,
  medium: 375,
  long: 1000
};
var Tooltip = function (_a) {
  var propsId = _a.id,
    className = _a.className,
    component = _a.component,
    children = _a.children,
    content = _a.content,
    _b = _a.mouseEnterDelay,
    mouseEnterDelay = _b === void 0 ? 'none' : _b,
    _c = _a.mouseOutDelay,
    mouseOutDelay = _c === void 0 ? 'none' : _c,
    metadata = _a.metadata,
    _d = _a.interactive,
    interactive = _d === void 0 ? true : _d,
    _e = _a.placement,
    placement = _e === void 0 ? 'top' : _e;
  var uid = utilsHooks.useId('tooltip-');
  var id = propsId || uid;
  var definedOffset = getComputedStyle(document.documentElement).getPropertyValue(styles.offsetVarName);
  var _f = utilsHooks.useAutoInteractions({
      role: {
        enabled: true,
        role: 'tooltip'
      },
      hover: {
        delay: {
          open: typeof mouseEnterDelay === 'number' ? mouseEnterDelay : DELAY_VALUES[mouseEnterDelay],
          close: typeof mouseOutDelay === 'number' ? mouseOutDelay : DELAY_VALUES[mouseOutDelay]
        },
        interactive: interactive
      },
      placement: placement,
      offset: definedOffset ? {
        offset: [parseInt(definedOffset, 10), parseInt(definedOffset, 10)]
      } : undefined
    }),
    triggerRef = _f.triggerRef,
    floatRef = _f.floatRef,
    floatStyles = _f.styles,
    open = _f.open,
    getTriggerProps = _f.getTriggerProps,
    getFloatProps = _f.getFloatProps;
  var childRef = utilsHooks.useForkRef([triggerRef,
  // TODO: Get rid of any type when working on PPUI-357
  children.ref]);
  return content ? React__default["default"].createElement(React__default["default"].Fragment, null, component || typeof children === 'string' ? React__default["default"].createElement(Trigger, __assign({
    component: component || 'span'
  }, getTriggerProps(__assign({
    className: className,
    ref: triggerRef
  }, utilsCommons.parseMetadata(metadata)))), children) : React.cloneElement(children, getTriggerProps(__assign(__assign(__assign({}, children.props), {
    ref: childRef
  }), utilsCommons.parseMetadata(metadata)))), open && React__default["default"].createElement(utilsPortalManager.GroupedPortal, null, React__default["default"].createElement("div", __assign({}, getFloatProps({
    className: styles.tooltip,
    id: id,
    ref: floatRef,
    style: floatStyles
  })), React__default["default"].createElement("div", null, content)))) : React__default["default"].createElement(React__default["default"].Fragment, null, children);
};
exports.Tooltip = Tooltip;
//# sourceMappingURL=index.js.map
